diff --git a/runtime/glbl.c b/runtime/glbl.c
index 1a32c2d664..befb64225b 100644
--- a/runtime/glbl.c
+++ b/runtime/glbl.c
@@ -987,6 +987,8 @@ glblProcessCnf(struct cnfobj *o)
 #else
 			stdlog_chanspec = (uchar*)
 				es_str2cstr(cnfparamvals[i].val.d.estr, NULL);
+			/* we need to re-open with the new channel */
+			stdlog_close(stdlog_hdl);
 			stdlog_hdl = stdlog_open("rsyslogd", 0, STDLOG_SYSLOG,
 					(char*) stdlog_chanspec);
 #endif
diff --git a/runtime/rsyslog.c b/runtime/rsyslog.c
index 9cdfa75455..710970c477 100644
--- a/runtime/rsyslog.c
+++ b/runtime/rsyslog.c
@@ -141,6 +141,7 @@ rsrtInit(const char **ppErrObj, obj_if_t *pObjIF)
 		/* init runtime only if not yet done */
 #ifdef HAVE_LIBLOGGING_STDLOG
 		stdlog_init(0);
+		stdlog_hdl = stdlog_open("rsyslogd", 0, STDLOG_SYSLOG, NULL);
 		stdlog_hdl = NULL;
 #endif
 		CHKiRet(pthread_attr_init(&default_thread_attr));
